﻿namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 플래그 설정 여부 구하기 - IsFlagSet(sourceType, flagType)

    /// <summary>
    /// 플래그 설정 여부 구하기
    /// </summary>
    /// <param name="sourceType">소스 타입</param>
    /// <param name="flagType">플래그 타입</param>
    /// <returns>플래그 설정 여부</returns>
    private static bool IsFlagSet(PetType sourceType, PetType flagType)
    {
        return (sourceType & flagType) == flagType;
    }

    #endregion
    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        PetType[] petTypeArray =
        {
            PetType.None,
            PetType.Dog | PetType.Cat,
            PetType.Dog
        };

        int noneCount = 0;
        int dogCount  = 0;

        foreach(PetType petType in petTypeArray)
        {
            if(petType.Equals(PetType.None))
            {
                noneCount++;
            }
            else if(IsFlagSet(petType, PetType.Dog))
            {
                dogCount++;
            }
        }

        Console.WriteLine("애완동물이 없는 경우 : {0}/{1}", noneCount, petTypeArray.Length);
        Console.WriteLine("개가 있는 경우       : {0}/{1}", dogCount , petTypeArray.Length);
    }

    #endregion
}